#version 330

layout(triangles) in;
layout (triangle_strip, max_vertices=6) out;

layout (std140) uniform Matrices {
	mat4 m_pvm;
	mat4 m_proj;
	mat4 m_model;
};

layout (std140) uniform Lights {
	vec4 l_dir;
};

uniform mat4 view1, view2;

in DataV2G {
	vec4 normal;
	vec2 texCoord;
} DataIn[];

out Data {
	vec3 normal;
	vec3 eye;
	vec3 lightDir;
	vec2 texCoord;
} DataOut;

void main() {

	gl_Layer = 0;
  for(int i = 0; i < gl_in.length(); ++i)
  {
     // copy position
    gl_Position = m_proj * (view1 * m_model * gl_in[i].gl_Position);
    gl_Position = m_pvm * gl_in[i].gl_Position;	
	DataOut.normal = vec3(view1 * m_model * DataIn[i].normal);
	DataOut.texCoord = DataIn[i].texCoord;
	DataOut.eye = - vec3(view1 * gl_in[i].gl_Position);
	DataOut.lightDir = vec3(view1 * l_dir);
    // done with the vertex
    EmitVertex();
  }
  EndPrimitive();


	gl_Layer = 1;
  for(int i = 0; i < gl_in.length(); ++i)
  {
     // copy position
    gl_Position = m_proj * (view2 * m_model * gl_in[i].gl_Position);
	DataOut.normal = vec3(view2 * m_model * DataIn[i].normal);
	DataOut.texCoord = DataIn[i].texCoord;
	DataOut.eye = - vec3(view2 * gl_in[i].gl_Position);
	DataOut.lightDir = vec3(view2 * l_dir);
    // done with the vertex
    EmitVertex();
  }
  EndPrimitive();
	
}